<?php

 session_start();

define("IPSET_LOCATION","/etc/dnsmasq.d/ipset-blocked.conf");
define("IPSET_NAME","blocked");
define("DNSMASQ_BINARY","/usr/sbin/dnsmasq");
define("SERVICE_COMMAND","/usr/sbin/service");
define("HEADING","Blockierte Domains - IPSET");


function getTargets()
{

        $rows_content=file(IPSET_LOCATION) or die("Could not read ipset location");


        $targets=array();


        for($i=0; $i<count($rows_content) ; $i++)
        {
                $cols_targets=explode("/",$rows_content[$i]);

                array_push($targets,$cols_targets[1]);

        }

        return $targets;
}

function checkConfig()
{

  if(!isset($_SERVER['PHP_AUTH_USER']))
  {

      die("No User Authentication sent. You must require htaccess Authentication");

  }

  if(! is_readable(IPSET_LOCATION))
       die("Cannot read IPSET_LOCATION please check");
  if(!is_writeable(IPSET_LOCATION))
       die("Cannot write IPSET_LOCATION please check");
   if(! is_readable(DNSMASQ_BINARY))
       die("Cannot read DNSMASQ binary");
   if(! is_readable(SERVICE_COMMAND))
       die("Cannot read SERVICE command");

}

function writeTargets($targets)
{

$ipsetString="";

for($i=0; $i<count($targets) ;$i++)
{
  if($targets[$i]!="TO_BE_DELETED")
{

  $ipsetString.="ipset=/".$targets[$i]."/".IPSET_NAME."\n";
}

}

return file_put_contents(IPSET_LOCATION,$ipsetString);


}

function restartDNSMASQ()
{


exec("sudo /usr/sbin/service dnsmasq restart",$output,$return_code);

return $return_code;

}


function checkAdd()
{

if(isset($_POST['add']) && isset($_POST['target_add']) && strlen($_POST['target_add'])>1 )
{

  $to_add=parse_url($_POST['target_add'],PHP_URL_HOST);

  if( $to_add===FALSE || !strlen($to_add))
  {

   $to_add="https://".$_POST['target_add'];
   
   $to_add=parse_url($to_add,PHP_URL_HOST);

  }



  if($to_add===FALSE || !strlen($to_add))
  {

   echo "Please use different Method e.g. http://www.hotmail.com/ leads to www.hotmail.com";

  }
  else
  {


	$targets=getTargets();


	if(in_array($to_add,$targets))
	{

	echo "Element is already there not need to add!";

	}
	else
	{


	array_push($targets,$to_add);

	if(writeTargets($targets)!==FALSE && restartDNSMASQ()==0)
        {
            echo "Successfully added ".$to_add;

        }
        else
        {
            echo "Could not add ".$to_add;
        }
    

	}




   }
}

}

function checkDelete()
{

if(isset($_POST['delete']) && isset($_POST['target_delete']))
{
   $to_delete=$_POST['target_delete'];

   $targets=getTargets();
  
   if(in_array($to_delete,$targets))
   {
      $pos=array_search($to_delete,$targets);

      $targets[$pos]="TO_BE_DELETED";

      /* Rebuild IPSET entries */

       if(writeTargets($targets)!==FALSE)
       {
             if(restartDNSMASQ()==0)
             {
                   echo "Successfully deleted $to_delete";
             }
             else
             {
                  echo "Couldn't restart DNSMASQ service";
             }
      
       }
       else
       {
         echo "Couldn't delete domain entry";
        }



   }
   else
   {
       echo "Cannot delete $to_delete entry";
   }


}

}


function checkAction()
{

checkConfig();
checkDelete();
checkAdd();


}



?>


<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Christian Czeczil">
    <link rel="icon" href="../../favicon.ico">

    <title><?php echo HEADING ?></title>

    <!-- Bootstrap core CSS -->
    <link href="bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <!-- Bootstrap theme -->
    <link href="boostrap/css/bootstrap-theme.min.css" rel="stylesheet">
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <link href="assets/css/ie10-viewport-bug-workaround.css" rel="stylesheet">

    <!-- Custom styles for this template -->
    <link href="theme.css" rel="stylesheet">


  </head>

  <body>



    <div class="container theme-showcase" role="main">

      <!-- Main jumbotron for a primary marketing message or call to action -->
      <div class="jumbotron">
        <h1><?php echo HEADING ?></h1>
      </div>

  <table class="table table-hover">
  <thead>
   <tr><th>Status</th></tr>
  </thead>
   <tr><td><?php checkAction(); ?></td></tr>
  </table>


<form action="./index.php" method="POST">

   <table class="table table-hover">
  <thead>
   <tr><th>Hostnamen hinzufügen</th></tr>
  </thead>
   <tbody>
   <tr><td><input type="text" class="form-control" name="target_add"></td></tr><tr><td><button type="submit" class="btn btn-default" name="add">Hinzufügen</button></td></tr>
  </tbody>
   </table>
  

</form>


   <table class="table table-hover">
            <thead>
              <tr>
                <th>Domain</th>
                <th>Aktion</th>
              </tr>
            </thead>
            <tbody>

  <?php

       $targets=getTargets();

        for($i=0; $i<count($targets) ;$i++)
        {
          $currentTarget=$targets[$i];
          
          echo '<tr>';

          echo "<td>".$currentTarget."</td>";

          echo '<td>';
        
          echo '<form action=./index.php method="POST">';
          echo '<input type="hidden" name="target_delete" value="'.$currentTarget.'">';
          echo '<button type="submit" class="btn btn-default" name="delete">Löschen</button>';
          echo '</form>';

          echo '</td>';
          echo '</tr>';


     }

 ?>

              </tbody>
          </table>
  
  </body>
</html>
